<template>
  <div>
    <Modal v-model="showEditModal" :mask-closable="false" :width="500" class="zIndex-1200">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <Form id="edit-form" ref="formObj" :model="formObj" :rules="ruleValidate" :label-width="100" inline>
          <Form-item label="收样位置" prop="name" style="width: 100%">
            <el-select v-model="formObj.locationId"  @change="selectLocation($event)" name="locationId">
              <el-option v-for="(item) in options" :label="item.name" :key="item.id" :value="item.id">
                {{ item.name }}
              </el-option>
            </el-select>
          </Form-item>
        </Form>
      </div>
      <div slot="footer">
        <ModalFooter ref="footerModal" @on-result-change="_footerResult" :footer="footerList"></ModalFooter>
      </div>
    </Modal>
  </div>
</template>
<script>
/**
 * 添加编辑
 */
import ModalFooter from '../../../components/base/modalFooter'
import { soilAptitude, soilEntrust, soilSample } from '../../../api'

export default {
  components: {
    ModalFooter
  },
  data() {
    return {
      formId: '',
      lengthLimitList: [
        { key: 'stdNum', title: '标准号' },
        { key: 'enName', title: '英文名称' },
        { key: 'belongUnit', title: '归口单位' },
        { key: 'publishUnit', title: '发布单位' }
      ],
      modalTitle: '添加食品标准表',
      formObj: {
        receiveLocation: '',
        locationId: ''
      },
      ruleValidate: {},
      showEditModal: false,
      ids: '',
      options: [],
      classifyList: [
        { value: 0, name: '判定依据' },
        { value: 1, name: '检测依据' },
        { value: 2, name: '其他' }
      ],
      typeList: [
        { value: 0, name: '国家标准' },
        { value: 1, name: '地方标准' },
        { value: 2, name: '行业标准' },
        { value: 3, name: '企业标准' }
      ],
      statusList: [
        { value: 0, name: '现行' },
        { value: 1, name: '即将实施' },
        { value: 2, name: '部分被代替' },
        { value: 3, name: '被代替' },
        { value: 4, name: '作废' }
      ],
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ]
    }
  },
  methods: {
    /** *modal-footer */
    selectLocation(data) {
      this._getLocationById(data)
    },
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(msg) {
      this.showEditModal = false
      this.$Message.success(msg)
      this.$emit('on-result-change')
      this._hideLoading()
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          this.formObj.ids = this.ids
          this._receive(this.formObj)
        } else {
          this.$Message.error('表单验证失败!')
          this._hideLoading()
        }
      })
    },
    _receive: async function(data) {
      const result = await soilEntrust.receiveSample(data)
      if (result) {
        this._resultChange('收样成功!')
      }
    },
    _save: async function(data) {
      const result = await soilAptitude.standardSave(data)
      if (result) {
        this._resultChange('添加成功!')
      }
    },
    _edit: async function(data) {
      const result = await soilAptitude.standardEdit(data)
      if (result) {
        this._resultChange('编辑成功!')
      }
    },
    _cancel() {
      this._hideLoading()
      this.showEditModal = false
    },
    _open(ids) {
      this.formObj.receiveLocation = ''
      this.formObj.locationId = ''
      this._getLocation()
      this.ids = ids
      this.showEditModal = true
    },
    _getLocation: async function() {
      const result = await soilSample.locationList()
      if (result) {
        console.log(result)
        this.options = result
        console.log(this.options)
      }
    },
    _getLocationById: async function(id) {
      console.log(id)
      const result = await soilSample.locationGetById(id)
      if (result) {
        this.formObj.receiveLocation = result.name
      }
      console.log(this.formObj.receiveLocation)
    },
    _registerAdd() {
      this.formId = this.$randomCode()
      this._hideLoading()
      this.$refs.formObj.resetFields()
      this.modalTitle = '添加'
      this.formObj.id = ''
      this.formObj.type = 3
      this.showEditModal = true
    }
  }
}
</script>
